% Get symmetric third deviator of a tensor
% INPUT:  A = 3rd order tensor
% OUTPUT  Sd_3 = third order deviator

function Sd_3 = Sd3(A)

Sd_3 = zeros(3,3,3);

% Symmetrize matrix
for i = 1:3
    for j = 1:3
        for k = 1:3
            Sd_3(i,j,k) = 1/6 * ( A(i,j,k) + A(j,i,k) + A(k,j,i) + A(k,i,j) + A(j,k,i) + A(i,k,j) );
        end
    end
end

% Make it traceless
for i = 1:3
    for j = 1:3
        for k = 1:3
            for m = 1:3
                for p = 1:3
                    Sd_3(i,j,k) = Sd_3(i,j,k) - 1/15 * ( (i==j)*(k==m) + (i==k)*(j==m) + (j==k)*(i==m) ) * ( A(p,p,m) + A(m,p,p) + A(p,m,p) );
                end
            end
        end
    end
end

end