% Get symmetric, 4th order deviator for A_{ij}B_{kl}, where A and B are 2nd
% order, symmetric, traceless tensors
function Sd_4 = Sd4(A, B)
Sd_4 = zeros(3,3,3,3);

for i = 1:3
    for j = 1:3
        for k = 1:3
            for m = 1:3
                Sd_4(i,j,k,m) = 1/6 * ( A(i,j) * B(k,m) + A(i,k) * B(j,m)+ A(i,m) * B(j,k) + A(j,k) * B(i,m) + A(j,m) * B(i,k) + A(k,m) * B(i,j) );
            end
        end
    end
end

Sd_2 = Sd2( A*B );

for i = 1:3
    for j = 1:3
        for k = 1:3
            for m = 1:3
                for p = 1:3
                    for q = 1:3
                        Sd_4(i,j,k,m) = Sd_4(i,j,k,m) - 2/21 * Sd_2(p,q) * ( (i==j) * (k==p) * (q==m) + ...
                                                                          (k==m) * (i==p) * (j==q) + ...
                                                                          (i==k) * (j==p) * (m==q) + ...
                                                                          (j==m) * (i==p) * (k==q) + ...
                                                                          (i==m) * (j==p) * (k==q) + ...
                                                                          (j==k) * (i==p) * (m==q) );
                    end
                end
            end
        end
    end
end

scalar = trace(A*B);

for i = 1:3
    for j = 1:3
        for k = 1:3
            for m = 1:3
                Sd_4(i,j,k,m) = Sd_4(i,j,k,m) - 2/45 * scalar * ( (i==j) * (k==m) + ...
                                                                (i==k) * (j==m) + ...
                                                                (i==m) * (j==k) );
            end
        end
    end
end

end



function output = Sd2(A)
output = 1/2 * (A + A') - 1/3 * trace(A) * eye(3);
end
