function [ED_Sd1, ED_Sd3] = get_pseudo_tensors(E,D)

% Define Levi_Civita
eps = zeros(3,3,3);
eps(1,2,3) = 1;    eps(2,3,1) = 1;     eps(3,1,2) = 1;
eps(1,3,2) = -1;   eps(2,1,3) = -1;    eps(3,2,1) = -1;

% First get 1st order pseudo tensor
ED = E*D;
ED_Sd1 = zeros(3,1);
for i = 1:3
    for j = 1:3
        for k = 1:3
            ED_Sd1(i) = ED_Sd1(i) + eps(i,j,k) * ED(j,k);
        end
    end
end


% Get 3rd order tensor and symmetric deviator
ED_3 = zeros(3,3,3);
for q = 1:3
    for r = 1:3
        for s = 1:3
            for j = 1:3
                for m = 1:3
                    ED_3(q,j,m) = ED_3(q,j,m) + eps(q,r,s) * E(r,j) * D(s,m);
                end
            end
        end
    end
end
ED_Sd3 = Sd3(ED_3);    % Symmetric deviator

end